StacKings = LibStub("AceAddon-3.0"):NewAddon("StacKings", "AceEvent-3.0", "AceConsole-3.0")
local StacKings = _G.StacKings

--[[
-- debug-stuff
--]]

--[===[@debug@
local PREFIX = "|cff00ff00Stack|r: "
local DevTools_Dump
DevTools_Dump = function(value)
	if not _G.DevTools_Dump then
		LoadAddOn("Blizzard_DebugTools")
	end
	DevTools_Dump = _G.DevTools_Dump
	DevTools_Dump(value)
end

local function dump(value)
	local orig = DEFAULT_CHAT_FRAME
	DEFAULT_CHAT_FRAME = ChatFrame4
	DevTools_Dump(value)
	DEFAULT_CHAT_FRAME = orig
end

local function mystrjoin(arg1, ...)
	local text = tostring(arg1)
	for i = 1, select('#', ...) do
		text = text .. tostring(select(i, ...))
	end
	return text
end

local doDebug
local function realDebug(arg1, ...)
	if not arg1 then return end
	if type(arg1) == 'table' then
		ChatFrame4:AddMessage(PREFIX .. "+++ table-dump")
		dump(arg1)
		ChatFrame4:AddMessage(PREFIX .. "--- end of table-dump")
		realDebug(...)
	else
		local text = mystrjoin(PREFIX, arg1, ...)
		ChatFrame4:AddMessage(text)
	end
end

local buffer = {}
local function collectDebug(...)
	buffer[#buffer + 1] = { ... }
end
doDebug = collectDebug

local function releaseDebug(self)
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	doDebug = realDebug
	for k,v in ipairs(buffer) do
		doDebug(unpack(v))
	end
	wipe(buffer)
	buffer = nil
end
local DebugFrame = CreateFrame('Frame')
DebugFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
DebugFrame:SetScript("OnEvent", releaseDebug)
--@end-debug@]===]

local function debug(...)
	--[===[@debug@
	doDebug(...)
	--@end-debug@]===]
end
StacKings.debug = debug

--[[
-- startup
--]]
function StacKings:OnInitialize()
	self:InitializeDB()
	self:InitOptions()
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function StacKings:OnEnable()
	self:UpdateAllBars()
end

function StacKings:PLAYER_ENTERING_WORLD()
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	self:InitializeBars()
end


